var focusedElement = null;
var savedValue;

const box_day = 1;
const box_year = 2;
const box_hour = 3;
const box_minute = 4;
const box_second = 5;
const box_ampm = 6;

/*changes the display color 
function change_color()
{
    document.getElementById("clocker-label-timeleft").style.color = document.getElementById("clocker-color").color; 
}
*/

/*displays time on the options window
function display_time()
{
var tm;

	tm = get_time_remaining();

    document.getElementById("clocker-label-timeleft").value = tm;
    window.setTimeout("display_time()", 1000);
}*/

//validates the input of time/date fields - resetting the field if bad input is provided
function validateInput(_isFinalInput, _box)
{
	var	input=focusedElement.value;
	var maxinput = 0;
	
	//alert("finalinput=" + _isFinalInput + " box=" + _box + "input" + input);
	
	if (_isFinalInput == true && input.length == 0)
	{
		focusedElement.value = savedValue;
		return;
	}
		
	if (_box != box_ampm && isNaN(input))
	{
		focusedElement.value = savedValue;
		return;
	}
	
	switch (_box) 
	{
        case box_day: //allow 1-31 based on month
			maxinput = 31;
			break;
        case box_year:
			maxinput = 2100;
			break;
        case box_hour:
			maxinput = 12;
			break;
        case box_minute:
			maxinput = 59;
			break;
        case box_second:
			maxinput = 59;
			break;
        case box_ampm:
			
			break;
		default:
			alert("ERROR - validateInput");
			focusedElement.value = savedValue;
			return;
	}		
	
	if (input < 0 || input > maxinput )
	{   //outside the range
		focusedElement.value = savedValue;
		return;
	}		
	
	if ((input.value.length != 0) && (input.value.charAt(0) != " "))
	{
		savedValue = input;	//accept current input
	}
}

//sets global focusedElement for a time/date field box 
function setFocus(_box)
{
//alert("HELLO" + _box);
	switch (_box) 
	{
        case box_day:
			focusedElement=document.getElementById("clocker-textbox-day");
			break;
        case box_year:
			focusedElement=document.getElementById("clocker-textbox-year");
			break;
        case box_hour:
			focusedElement=document.getElementById("clocker-textbox-hour");
			break;
        case box_minute:
			focusedElement=document.getElementById("clocker-textbox-minute");
			break;
        case box_second:
			focusedElement=document.getElementById("clocker-textbox-second");
			break;
        case box_ampm:
			focusedElement=document.getElementById("clocker-textbox-ampm");
			break;
		default:
			alert("ERROR - setfocus");
			return;
	}	
//	alert("bye" + box);
	focusedElement.select();
	
	if ((focusedElement.value.length != 0) && (focusedElement.value.charAt(0) != " "))
	//if (!isNaN(focusedElement.value))
	{
		savedValue=focusedElement.value;
	}
}

//increments/decrements the time/date fields when using the +/- buttons
function adjust(_direction)
{
	//alert("hello");
	var maxinput = 0;
	var mininput = 0;
	
	if (focusedElement == null)
	{
		setFocus(box_day);
	}
	
	var	input = focusedElement.value;
	var id = focusedElement.getAttribute("id");
	
	switch(id)
	{	//get the box being adjusted
		case "clocker-textbox-day":
			maxinput = 31;
			break;
		case "clocker-textbox-year":
			maxinput = 2100;
			mininput = 2005;
			break;
		case "clocker-textbox-hour":
			maxinput = 12;
			break;
		case "clocker-textbox-minute":
			maxinput = 59;
			break;
		case "clocker-textbox-second":
			maxinput = 59;
			break;
		case "clocker-textbox-ampm":
			if (input == "AM")
				focusedElement.value = "PM";
			else
				focusedElement.value = "AM";
			focusedElement.select();
			return;
		default:
			alert("Error - adjust");
			return;
	}
	
	if (input.length == 0)
		input = mininput;
	
	if (_direction == 0)
	{
		if (input >= maxinput)
			input = mininput;
		else
			input++;
	}
	else
	{
		if (input <= mininput)
			input = maxinput;
		else
			input--;
	}
	
	focusedElement.value = input;
	
	focusedElement.select();
	
	return;
}

//saves all fields when OK is clicked
function clocker_saveOptions()
{
    var clockerPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("clocker.");
    var box;

	//time and date
    clockerPrefs.setCharPref("optMonth", document.getElementById("clocker-menulist-month").value);
    clockerPrefs.setCharPref("optYear", document.getElementById("clocker-textbox-year").value);
    clockerPrefs.setCharPref("optDay", document.getElementById("clocker-textbox-day").value);
    clockerPrefs.setCharPref("optHour", document.getElementById("clocker-textbox-hour").value);
    clockerPrefs.setCharPref("optMinute", document.getElementById("clocker-textbox-minute").value);
    clockerPrefs.setCharPref("optSecond", document.getElementById("clocker-textbox-second").value); 
    clockerPrefs.setCharPref("optAmpm", document.getElementById("clocker-textbox-ampm").value); 
    
    //display
    clockerPrefs.setCharPref("optColor", document.getElementById("clocker-color").color);
    clockerPrefs.setCharPref("optEventDesc", document.getElementById("clocker-textbox-event").value);
    clockerPrefs.setBoolPref("optDisplayEvent", document.getElementById("clocker-checkbox").checked);
    
    precisionSelected = document.getElementById("clocker-precision").selectedItem 
	if (precisionSelected == document.getElementById("clocker-precision-days"))
		box = "days"
	else if (precisionSelected == document.getElementById("clocker-precision-hours"))
		box = "hours"
	else if (precisionSelected == document.getElementById("clocker-precision-minutes"))
		box = "minutes"
	else 
		box = "seconds"
		
   	clockerPrefs.setCharPref("optPrecision", box); 		

    formatSelected = document.getElementById("clocker-format").selectedItem 
	if (formatSelected == document.getElementById("clocker-format-veryshort"))
		box = "vshort"
	else if (formatSelected == document.getElementById("clocker-format-short"))
		box = "short"
	else 
		box = "long"

   	clockerPrefs.setCharPref("optFormat", box); 
   	
   	clockerPrefs = null;

}

//Initialize elements when options window is opened
function clocker_initializeOptions()
{
    var clockerPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("clocker.");

	//time and date
	document.getElementById("clocker-menulist-month").value = clockerPrefs.getCharPref("optMonth");
	document.getElementById("clocker-textbox-year").value = clockerPrefs.getCharPref("optYear");
	document.getElementById("clocker-textbox-day").value = clockerPrefs.getCharPref("optDay");
	document.getElementById("clocker-textbox-hour").value = clockerPrefs.getCharPref("optHour");
	document.getElementById("clocker-textbox-minute").value = clockerPrefs.getCharPref("optMinute");
	document.getElementById("clocker-textbox-second").value = clockerPrefs.getCharPref("optSecond");	
	document.getElementById("clocker-textbox-ampm").value = clockerPrefs.getCharPref("optAmpm");	
	
	//display	
	document.getElementById("clocker-color").color = clockerPrefs.getCharPref("optColor");
	//document.getElementById("clocker-label-timeleft").style.color = clockerPrefs.getCharPref("optColor");
	document.getElementById("clocker-textbox-event").value = clockerPrefs.getCharPref("optEventDesc");   
	document.getElementById("clocker-checkbox").checked = clockerPrefs.getBoolPref("optDisplayEvent");   
	
	if (clockerPrefs.getCharPref("optPrecision") == "days")
		document.getElementById("clocker-precision").selectedItem = document.getElementById("clocker-precision-days");
	else if (clockerPrefs.getCharPref("optPrecision") == "hours")
		document.getElementById("clocker-precision").selectedItem = document.getElementById("clocker-precision-hours");
	else if (clockerPrefs.getCharPref("optPrecision") == "minutes")
		document.getElementById("clocker-precision").selectedItem = document.getElementById("clocker-precision-minutes");		
	else
		document.getElementById("clocker-precision").selectedItem = document.getElementById("clocker-precision-seconds");

	if (clockerPrefs.getCharPref("optFormat") == "vshort")
		document.getElementById("clocker-format").selectedItem = document.getElementById("clocker-format-veryshort");
	else if (clockerPrefs.getCharPref("optFormat") == "short")
		document.getElementById("clocker-format").selectedItem = document.getElementById("clocker-format-short");		
	else
		document.getElementById("clocker-format").selectedItem = document.getElementById("clocker-format-long");

	clockerPrefs = null;
}
